diff -Nur dovecot-2.0.beta5/src/lib-imap/imap-url.h dovecot-2.0.beta5+lemonade/src/lib-imap/imap-url.h
--- dovecot-2.0.beta5/src/lib-imap/imap-url.h	1969-12-31 18:00:00.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/lib-imap/imap-url.h	2010-06-11 13:12:14.000000000 -0500
@@ -0,0 +1,100 @@
+/*
+ * Copyright (c) 2010 Apple Inc. All rights reserved.
+ * 
+ * Redistribution and use in source and binary forms, with or without  
+ * modification, are permitted provided that the following conditions  
+ * are met:
+ * 
+ * 1.  Redistributions of source code must retain the above copyright  
+ * notice, this list of conditions and the following disclaimer.
+ * 2.  Redistributions in binary form must reproduce the above  
+ * copyright notice, this list of conditions and the following  
+ * disclaimer in the documentation and/or other materials provided  
+ * with the distribution.
+ * 3.  Neither the name of Apple Inc. ("Apple") nor the names of its  
+ * contributors may be used to endorse or promote products derived  
+ * from this software without specific prior written permission.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND 
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,  
+ * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A  
+ * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS  
+ * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT  
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
+ * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND  
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF  
+ * SUCH DAMAGE.
+ */
+
+/* APPLE - urlauth, catenate */
+
+#ifndef IMAP_URL_H
+#define IMAP_URL_H
+
+struct imap_url_parts {
+	const char *user;
+	const char *auth_type;
+	const char *hostport;
+	const char *mailbox;
+	const char *uidvalidity;
+	const char *uid;
+	const char *section;
+	const char *expiration;
+	time_t expiration_time;
+	const char *access;
+	const char *mechanism;
+	const char *urlauth;
+
+	const char *rump;
+};
+
+// URL-decode enc into dec (%XX decoding)
+bool url_decode(const char *enc, string_t *dec);
+
+// parse an RFC 2192+4467 URL into its parts
+void imap_url_parse(const char *url, struct imap_url_parts *parts);
+
+// decode the parts of an IMAP URL
+bool imap_url_decode(const struct imap_url_parts *enc_parts,
+		     struct imap_url_parts *dec_parts,
+		     const char **error);
+
+// validate conformance to RFC 3501 "atom"
+bool imap_url_atom_validate(const char *s);
+// validate conformance to RFC 3501 "ASTRING-CHAR"
+bool imap_url_astring_chars_validate(const char *s);
+// validate conformance to RFC 3501 "quoted"
+bool imap_url_quoted_validate(const char *s);
+// validate conformance to RFC 3501 "literal"
+bool imap_url_literal_validate(const char *s);
+// validate conformance to RFC 3501 "astring"
+bool imap_url_astring_validate(const char *s);
+// validate conformance to RFC 1738 "hostport"
+bool imap_url_hostport_validate(const char *s);
+// validate conformance to RFC 3501 "mailbox"
+bool imap_url_mailbox_validate(const char *s);
+// validate conformance to RFC 3501 "nz_number"
+bool imap_url_nz_number_validate(const char *s);
+// validate conformance to RFC 3501 "section-text"
+bool imap_url_section_text_validate(const char *s);
+// validate conformance to RFC 2192 "section"
+bool imap_url_section_validate(const char *s);
+// validate conformance to RFC 3339 "date-time"
+bool imap_url_datetime_validate(const char *s);
+// validate conformance to RFC 4467 "access"
+bool imap_url_access_validate(const char *s);
+// validate conformance to RFC 4467 "mechanism"
+bool imap_url_mechanism_validate(const char *s);
+// validate conformance to RFC 4467 "urlauth" (really enc-urlauth)
+bool imap_url_urlauth_validate(const char *s);
+
+// build a URL from parts
+void imap_url_construct(const struct imap_url_parts *parts, string_t *url);
+
+// filter a URL according to RFC 4469 url-resp-text
+const char *imap_url_sanitize(const char *url);
+
+#endif
diff -Nur dovecot-2.0.beta5/src/plugins/Makefile.am dovecot-2.0.beta5+lemonade/src/plugins/Makefile.am
--- dovecot-2.0.beta5/src/plugins/Makefile.am	2010-02-12 21:46:23.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/plugins/Makefile.am	2010-06-11 13:12:14.000000000 -0500
@@ -25,6 +25,7 @@
 	quota \
 	imap-quota \
 	trash \
+	urlauth \
 	virtual \
 	$(ZLIB) \
 	$(FTS_LUCENE) \
diff -Nur dovecot-2.0.beta5/src/plugins/acl/acl-mailbox-list.c dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-mailbox-list.c
--- dovecot-2.0.beta5/src/plugins/acl/acl-mailbox-list.c	2010-03-25 10:03:33.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-mailbox-list.c	2010-06-11 13:12:14.000000000 -0500
@@ -534,6 +534,11 @@
 
 	owner_username = list->ns->user->username;
 	current_username = auser->master_user;
+
+	/* APPLE - urlauth */
+	if (current_username == NULL)
+		current_username = auser->submit_user;
+
 	if (current_username == NULL)
 		current_username = owner_username;
 	else
diff -Nur dovecot-2.0.beta5/src/plugins/acl/acl-plugin.h dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-plugin.h
--- dovecot-2.0.beta5/src/plugins/acl/acl-plugin.h	2010-02-06 08:50:10.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-plugin.h	2010-06-11 13:12:14.000000000 -0500
@@ -17,6 +17,7 @@
 	union mail_user_module_context module_ctx;
 
 	const char *master_user;
+	const char *submit_user;			/* APPLE - urlauth */
 	const char *acl_env;
 	const char *const *groups;
 
diff -Nur dovecot-2.0.beta5/src/plugins/acl/acl-storage.c dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-storage.c
--- dovecot-2.0.beta5/src/plugins/acl/acl-storage.c	2010-02-06 09:30:23.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/plugins/acl/acl-storage.c	2010-06-11 13:12:14.000000000 -0500
@@ -35,6 +35,8 @@
 
 	auser->acl_env = env;
 	auser->master_user = mail_user_plugin_getenv(user, "master_user");
+	/* APPLE - urlauth */
+	auser->submit_user = mail_user_plugin_getenv(user, "submit_user");
 
 	env = mail_user_plugin_getenv(user, "acl_groups");
 	if (env != NULL) {
diff -Nur dovecot-2.0.beta5/src/plugins/imap-zlib/imap-zlib-plugin.c dovecot-2.0.beta5+lemonade/src/plugins/imap-zlib/imap-zlib-plugin.c
--- dovecot-2.0.beta5/src/plugins/imap-zlib/imap-zlib-plugin.c	2010-04-12 11:14:53.000000000 -0500
+++ dovecot-2.0.beta5+lemonade/src/plugins/imap-zlib/imap-zlib-plugin.c	2010-06-11 13:12:14.000000000 -0500
@@ -30,7 +30,7 @@
 static MODULE_CONTEXT_DEFINE_INIT(imap_zlib_imap_module,
 				  &imap_module_register);
 
-static void client_skip_line(struct client *client)
+static void imap_zlib_client_skip_line(struct client *client)
 {
 	const unsigned char *data;
 	size_t data_size;
@@ -99,7 +99,7 @@
 		return TRUE;
 	}
 
-	client_skip_line(client);
+	imap_zlib_client_skip_line(client);
 	client_send_tagline(cmd, "OK Begin compression.");
 
 	value = mail_user_plugin_getenv(client->user,
diff -Nur dovecot-2.0.beta5/src/plugins/urlauth/Makefile.am dovecot-2.0.beta5+lemonade/src/plugins/urlauth/Makefile.am
--- dovecot-2.0.beta5/src/plugins/urlauth/Makefile.am	1969-12-31 18:00:00.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/plugins/urlauth/Makefile.am	2010-06-11 13:12:14.000000000 -0500
@@ -0,0 +1,52 @@
+#
+# Copyright (c) 2010 Apple Inc. All rights reserved.
+# 
+# Redistribution and use in source and binary forms, with or without  
+# modification, are permitted provided that the following conditions  
+# are met:
+# 
+# 1.  Redistributions of source code must retain the above copyright  
+# notice, this list of conditions and the following disclaimer.
+# 2.  Redistributions in binary form must reproduce the above  
+# copyright notice, this list of conditions and the following  
+# disclaimer in the documentation and/or other materials provided  
+# with the distribution.
+# 3.  Neither the name of Apple Inc. ("Apple") nor the names of its  
+# contributors may be used to endorse or promote products derived  
+# from this software without specific prior written permission.
+# 
+# THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND  
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,  
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A  
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS  
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT  
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF  
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND  
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF  
+# SUCH DAMAGE.
+#
+
+AM_CPPFLAGS = \
+	-I$(top_srcdir)/src/lib \
+	-I$(top_srcdir)/src/lib-imap \
+	-I$(top_srcdir)/src/lib-index \
+	-I$(top_srcdir)/src/lib-mail \
+	-I$(top_srcdir)/src/lib-storage \
+	-I$(top_srcdir)/src/imap
+
+lib10_urlauth_plugin_la_LDFLAGS = -module -avoid-version
+lib10_urlauth_plugin_la_LIBADD = -lcrypto
+
+module_LTLIBRARIES = \
+	lib10_urlauth_plugin.la
+
+lib10_urlauth_plugin_la_SOURCES = \
+	urlauth-keys.c \
+	urlauth-plugin.c \
+	urlauth.c
+
+noinst_HEADERS = \
+	urlauth-plugin.h
diff -Nur dovecot-2.0.beta5/src/plugins/urlauth/urlauth-keys.c dovecot-2.0.beta5+lemonade/src/plugins/urlauth/urlauth-keys.c
--- dovecot-2.0.beta5/src/plugins/urlauth/urlauth-keys.c	1969-12-31 18:00:00.000000000 -0600
+++ dovecot-2.0.beta5+lemonade/src/plugins/urlauth/urlauth-keys.c	2010-06-11 13:12:14.000000000 -0500
@@ -0,0 +1,257 @@
+/*
+ * Copyright (c) 2010 Apple Inc. All rights reserved.
+ * 
+ * Redistribution and use in source and binary forms, with or without  
+ * modification, are permitted provided that the following conditions  
+ * are met:
+ * 
+ * 1.  Redistributions of source code must retain the above copyright  
+ * notice, this list of conditions and the following disclaimer.
+ * 2.  Redistributions in binary form must reproduce the above  
+ * copyright notice, this list of conditions and the following  
+ * disclaimer in the documentation and/or other materials provided  
+ * with the distribution.
+ * 3.  Neither the name of Apple Inc. ("Apple") nor the names of its  
+ * contributors may be used to endorse or promote products derived  
+ * from this software without specific prior written permission.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND 
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,  
+ * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A  
+ * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS  
+ * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT  
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
+ * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND  
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF  
+ * SUCH DAMAGE.
+ */
+
+#include "lib.h"
+#include "istream.h"
+#include "ostream.h"
+#include "hash.h"
+#include "mail-storage-private.h"
+#include "hex-binary.h"
+#include "randgen.h"
+#include "urlauth-plugin.h"
+
+#include <ctype.h>
+
+#define URLAUTH_KEYS_FILENAME	"urlauthkeys"
+
+enum urlauth_keys_action {
+	URLAUTH_KEYS_GET,	// get the key for a mailbox
+	URLAUTH_KEYS_SET,	// set a new random key for a mailbox
+	URLAUTH_KEYS_DELETE	// delete the key for a mailbox
+};
+
+// get the path to the access keys table
+static const char *urlauth_keys_path(struct mailbox_list *list)
+{
+	const char *control_dir =
+		mailbox_list_get_path(list, NULL,
+				      MAILBOX_LIST_PATH_TYPE_CONTROL);
+	return t_strconcat(control_dir, "/"URLAUTH_KEYS_FILENAME, NULL);
+	
+}
+
+// read the access keys into the hash table
+static struct hash_table *urlauth_keys_read(pool_t pool, int fd)
+{
+	struct hash_table *keys;
+	struct istream *is;
+	const char *line;
+
+	is = i_stream_create_fd(fd, 4096, FALSE);
+	if (is == NULL)
+		return NULL;
+
+	keys = hash_table_create(pool, pool, 16, strcase_hash,
+				 (hash_cmp_callback_t *) strcasecmp);
+	if (keys == NULL) {
+		i_stream_destroy(&is);
+		return NULL;
+	}
+
+	i_stream_set_return_partial_line(is, TRUE);
+	while ((line = i_stream_read_next_line(is)) != NULL) {
+		const char *sep;
+
+		if (*line == '\0' || *line == '#')
+			continue;
+
+		/* future-proofing */
+		if (strcmp(line, URLAUTH_KEYS_FILENAME" version 1") == 0)
+			continue;
+
+		/* key:mailbox, both nonempty */
+		sep = strchr(line, ':');
+		if (sep == NULL || sep == line || sep[1] == '\0')
+			continue;
+
+		/* keys[mailbox] = key */
+		hash_table_insert(keys,
+				  p_strdup(pool, sep + 1),
+				  p_strdup_until(pool, line, sep));
+	}
+	i_stream_destroy(&is);
+
+	return keys;
+}
+
+// write the access keys to the file
+static bool urlauth_keys_write(int fd, struct hash_table *keys)
+{
+	struct ostream *os;
+	struct hash_iterate_context *iter;
+	void *key, *value;
+
+	os = o_stream_create_fd_file(fd, 0, FALSE);
+	if (os == NULL)
+		return NULL;
+
+	o_stream_send_str(os, URLAUTH_KEYS_FILENAME" version 1\n");
+	iter = hash_table_iterate_init(keys);
+	while (hash_table_iterate(iter, &key, &value)) {
+		/* key is the mailbox, value is the access key */
+		o_stream_send_str(os, (const char *) value);
+		o_stream_send(os, ":", 1);
+		o_stream_send_str(os, (const char *) key);
+		o_stream_send(os, "\n", 1);
+	}
+	hash_table_iterate_deinit(&iter);
+	o_stream_destroy(&os);
+
+	return TRUE;
+}
+
+// read/modify/write the access keys
+static bool urlauth_keys_update(struct mailbox *box,
+				enum urlauth_keys_action action,
+				buffer_t *out_key)
+{
+	const char *path;
+	int flags, fd;
+	pool_t pool;
+	struct hash_table *keys;
+	unsigned char new_key[URLAUTH_KEY_BYTES];
+	const char *hex = NULL;
+	bool modified = FALSE;
+
+	/* open and lock the keys file */
+	path = urlauth_keys_path(box->list);
+	flags = O_RDWR | O_EXLOCK;
+	if (action == URLAUTH_KEYS_GET || action == URLAUTH_KEYS_SET)
+		flags |= O_CREAT;
+	fd = open(path, flags, 0644);
+	if (fd < 0) {
+		if ((flags & O_CREAT) || errno != ENOENT)
+			i_error("open(%s) failed: %m", path);
+		return FALSE;
+	}
+
+	/* read the keys */
+	pool = pool_alloconly_create("urlauth_keys", 1024);
+	keys = urlauth_keys_read(pool, fd);
+	if (keys == NULL) {
+		i_error("error reading %s: %m", path);
+		pool_unref(&pool);
+		close(fd);
+		return FALSE;
+	}
+
+	/* modify the keys */
+	switch (action) {
+	case URLAUTH_KEYS_GET:
+		hex = hash_table_lookup(keys, (void *) box->name);
+
+		/* if hex key is bogus, set a new one */
+		if (hex) {
+			const char *cp;
+			for (cp = hex; *cp; cp++)
+				if (!i_isxdigit(*cp))
+					break;
+			if (*cp == '\0')
+				break;	/* good hex */
+		}
+
+		/* if not present, set one -- fall through */
+	case URLAUTH_KEYS_SET:
+		random_fill(new_key, sizeof new_key);
+		hex = binary_to_hex(new_key, sizeof new_key);
+		if (*box->name) {
+			hash_table_insert(keys, (void *) box->name,
+					  (void *) hex);
+			modified = TRUE;
+		} /* else box->name="" for foiling timing attacks */
+		break;
+	case URLAUTH_KEYS_DELETE:
+		hex = hash_table_lookup(keys, (void *) box->name);
+		if (hex) {
+			hash_table_remove(keys, (void *) box->name);
+			modified = TRUE;
+		}
+		break;
+	}
+
+	if (out_key)
+		hex_to_binary(hex, out_key);
+
+	/* write the keys */
+	if (modified) {
+		lseek(fd, 0, SEEK_SET);
+		ftruncate(fd, 0);
+		urlauth_keys_write(fd, keys);
+	}
+
+	/* clean up */
+	close(fd);
+	hash_table_destroy(&keys);
+	pool_unref(&pool);
+
+	return TRUE;
+}
+
+void urlauth_keys_init(void)
+{
+	random_init();
+}
+
+void urlauth_keys_deinit(void)
+{
+	random_deinit();
+}
+
+// get the access key for a mailbox
+bool urlauth_keys_get(struct mailbox *box, buffer_t *key)
+{
+	return urlauth_keys_update(box, URLAUTH_KEYS_GET, key);
+}
+
+// set a new random access key for a mailbox
+bool urlauth_keys_set(struct mailbox *box)
+{
+	return urlauth_keys_update(box, URLAUTH_KEYS_SET, NULL);
+}
+
+// delete the access key for a mailbox
+bool urlauth_keys_delete(struct mailbox *box)
+{
+	return urlauth_keys_update(box, URLAUTH_KEYS_DELETE, NULL);
+}
+
+// delete all access keys
+bool urlauth_keys_reset(struct mailbox_list *list)
+{
+	const char *path;
+
+	path = urlauth_keys_path(list);
+	if (unlink(path) < 0 && errno != ENOENT && errno != ESTALE) {
+		i_error("unlink(%s) failed: %m", path);
+		return FALSE;
+	}
+	return TRUE;
+}
